# Implement Google and GitHub OAuth2 in Rust Frontend App

In this article, you will learn how to implement OAuth for Google and GitHub in a Rust frontend application using the Yew.rs framework. Additionally, I will provide backend APIs built using Rust, Node.js, and Golang that you can use alongside the frontend application.

![Implement Google and GitHub OAuth2 in Rust Frontend App](https://codevoweb.com/wp-content/uploads/2023/05/Implement-Google-and-GitHub-OAuth2-in-Rust-Frontend-App.webp)

## Topics Covered

- Run the Google and GitHub OAuth Frontend App
- Run a Rust Backend Server with the App
- Other Backend APIs with OAuth Support
- How the GitHub and Google OAuth Works
    - Sign In using Google OAuth
    - Sign In using GitHub OAuth
- Setup the Rust Frontend Project
- Generate the GitHub and Google OAuth Consent Screen URLs
    - Function to Generate the Google OAuth Consent Screen
    - Function to Generate the GitHub OAuth Consent Screen
- Set up Tailwind CSS for Styling
- Create the API Request Functions
- Manage the Application State Globally
- Create Some Reusable Components
    - Create a Spinner Component
    - Create a Form Input Component
    - Create an Alert Notification Component
    - Create a Header Component
- Create the Frontend Pages for the Authentication
    - Account Registration Page
    - Account Login Page
    - Profile Page
    - Home Page
- Create Routes for the Page Components
- Create the App Component
- Render the App Component in the Main File
- How to Obtain the Google OAuth Credentials
- How to Obtain the GitHub OAuth Credentials
- Conclusion

Read the entire article here: [https://codevoweb.com/implement-google-and-github-oauth2-in-rust-frontend-app/](https://codevoweb.com/implement-google-and-github-oauth2-in-rust-frontend-app/)

